<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tower Attack: menu.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tower Attack
   </div>
   <div id="projectbrief">A simple console game</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">menu.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef V1_1_MENU_H</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define V1_1_MENU_H</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#define DEFAULTWIDTH    66</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DEFAULTHEIGHT   20</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#define CENTER           1</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#define LEFT             0</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define RIGHT            2</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#define NEW           true</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define LOADED       false</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;climits&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;game.h&quot;</span>   <span class="comment">// also includes cmap.h, entities.h, coords.h, config.h</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="classCantOpenFile.html">   17</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCantOpenFile.html">CantOpenFile</a>{};</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classCMenu.html">   24</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">string</span>                 readInput       ( <span class="keywordtype">void</span> ) <span class="keyword">const</span>;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordtype">void</span>                   printError      ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; error) <span class="keyword">const</span>;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordtype">void</span>                   printEmptyLine  ( <span class="keywordtype">int</span> lines = 1) <span class="keyword">const</span>;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">void</span>                   printBorder     () <span class="keyword">const</span>;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordtype">void</span>                   printString     ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; str, <span class="keywordtype">int</span> position = CENTER) <span class="keyword">const</span>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordtype">void</span>                   middleLine      ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; line) <span class="keyword">const</span>;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">void</span>                   printFolderMenu ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; folder) <span class="keyword">const</span>;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <a class="code" href="classCMenu.html">CMenu</a> *                playGame        ( <a class="code" href="classCGame.html">CGame</a> &amp; game);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">int</span>                    printFolder     ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; folder ) <span class="keyword">const</span>;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    vector&lt;string&gt;         loadFolder      ( <span class="keyword">const</span> <span class="keywordtype">string</span> &amp; folder ) <span class="keyword">const</span>;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classCMenu.html">CMenu</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classCMenu.html">CMenu</a> * selectOption ( );</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span>    show ( ) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;};</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="classCMainMenu.html">   43</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCMainMenu.html">CMainMenu</a>   : <span class="keyword">public</span> <a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keywordtype">void</span>    show ( ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <a class="code" href="classCMenu.html">CMenu</a> * selectOption ( ) <span class="keyword">override</span>;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;};</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classCNewMenu.html">   50</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCNewMenu.html">CNewMenu</a>  : <span class="keyword">public</span> <a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <a class="code" href="classCMenu.html">CMenu</a> * selectOption ( ) <span class="keyword">override</span>;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">void</span>    show ( ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    vector &lt;string&gt; m_files;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;};</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="classCGamesMenu.html">   59</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCGamesMenu.html">CGamesMenu</a>  : <span class="keyword">public</span> <a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordtype">void</span>    show ( ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <a class="code" href="classCMenu.html">CMenu</a> * selectOption ( ) <span class="keyword">override</span>;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    vector &lt;string&gt; m_files;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;};</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classCScoreMenu.html">   68</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCScoreMenu.html">CScoreMenu</a> : <span class="keyword">public</span> <a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">void</span>    show ( ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;};</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classCManualPage1.html">   74</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCManualPage1.html">CManualPage1</a>  : <span class="keyword">public</span> <a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">void</span>    show ( ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <a class="code" href="classCMenu.html">CMenu</a> * selectOption ( ) <span class="keyword">override</span>;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;};</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="classCManualPage2.html">   81</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCManualPage2.html">CManualPage2</a>  : <span class="keyword">public</span> <a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">void</span>    show ( ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <a class="code" href="classCMenu.html">CMenu</a> * selectOption ( ) <span class="keyword">override</span>;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;};</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="classCManualPage3.html">   88</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCManualPage3.html">CManualPage3</a>  : <span class="keyword">public</span> <a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordtype">void</span>    show ( ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <a class="code" href="classCMenu.html">CMenu</a> * selectOption ( ) <span class="keyword">override</span>;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;};</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno"><a class="line" href="classCWinner.html">   95</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCWinner.html">CWinner</a>  : <span class="keyword">public</span> <a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordtype">void</span>    show ( ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;};</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="classCLoser.html">  101</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCLoser.html">CLoser</a>  : <span class="keyword">public</span> <a class="code" href="classCMenu.html">CMenu</a> {</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordtype">void</span>    show ( ) <span class="keyword">const override</span>;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;};</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="classCMenuController.html">  107</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCMenuController.html">CMenuController</a> {</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <a class="code" href="classCMenu.html">CMenu</a>      * currentMenu;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="classCMenuController.html#a2d8c607ea3be11d74c41e6f07deba372">  112</a></span>&#160;    <a class="code" href="classCMenuController.html#a2d8c607ea3be11d74c41e6f07deba372">CMenuController</a> ( ) : currentMenu ( new <a class="code" href="classCMainMenu.html">CMainMenu</a> ){}</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <a class="code" href="classCMenuController.html">CMenuController</a> ( <span class="keyword">const</span> <a class="code" href="classCMenuController.html">CMenuController</a> &amp; src ) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordtype">void</span> operator = ( <span class="keyword">const</span> <a class="code" href="classCMenuController.html">CMenuController</a> &amp; src ) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    ~<a class="code" href="classCMenuController.html">CMenuController</a>(){ <span class="keyword">delete</span> currentMenu; }</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keywordtype">void</span> start ( <span class="keywordtype">void</span> );</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;};</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="preprocessor">#endif //V1_1_MENU_H</span></div><div class="ttc" id="classCGame_html"><div class="ttname"><a href="classCGame.html">CGame</a></div><div class="ttdoc">CGame represents the game with its engine, gamePlan, entities, etc... </div><div class="ttdef"><b>Definition:</b> game.h:15</div></div>
<div class="ttc" id="classCManualPage2_html"><div class="ttname"><a href="classCManualPage2.html">CManualPage2</a></div><div class="ttdoc">Second page of manual. </div><div class="ttdef"><b>Definition:</b> menu.h:81</div></div>
<div class="ttc" id="classCMainMenu_html"><div class="ttname"><a href="classCMainMenu.html">CMainMenu</a></div><div class="ttdoc">Main menu. </div><div class="ttdef"><b>Definition:</b> menu.h:43</div></div>
<div class="ttc" id="classCManualPage3_html"><div class="ttname"><a href="classCManualPage3.html">CManualPage3</a></div><div class="ttdoc">Third page of manual. </div><div class="ttdef"><b>Definition:</b> menu.h:88</div></div>
<div class="ttc" id="classCantOpenFile_html"><div class="ttname"><a href="classCantOpenFile.html">CantOpenFile</a></div><div class="ttdoc">Object used for exception only. </div><div class="ttdef"><b>Definition:</b> menu.h:17</div></div>
<div class="ttc" id="classCNewMenu_html"><div class="ttname"><a href="classCNewMenu.html">CNewMenu</a></div><div class="ttdoc">New game menu. </div><div class="ttdef"><b>Definition:</b> menu.h:50</div></div>
<div class="ttc" id="classCMenu_html"><div class="ttname"><a href="classCMenu.html">CMenu</a></div><div class="ttdoc">Menu class Abstract class with a basic set of methods to draw parts of menu. </div><div class="ttdef"><b>Definition:</b> menu.h:24</div></div>
<div class="ttc" id="classCMenuController_html_a2d8c607ea3be11d74c41e6f07deba372"><div class="ttname"><a href="classCMenuController.html#a2d8c607ea3be11d74c41e6f07deba372">CMenuController::CMenuController</a></div><div class="ttdeci">CMenuController()</div><div class="ttdoc">Sets main menu as current menu. </div><div class="ttdef"><b>Definition:</b> menu.h:112</div></div>
<div class="ttc" id="classCMenuController_html"><div class="ttname"><a href="classCMenuController.html">CMenuController</a></div><div class="ttdoc">Handles transitions between menu screens and user input. </div><div class="ttdef"><b>Definition:</b> menu.h:107</div></div>
<div class="ttc" id="classCWinner_html"><div class="ttname"><a href="classCWinner.html">CWinner</a></div><div class="ttdoc">Show winning screen. </div><div class="ttdef"><b>Definition:</b> menu.h:95</div></div>
<div class="ttc" id="classCLoser_html"><div class="ttname"><a href="classCLoser.html">CLoser</a></div><div class="ttdoc">Show losing screen. </div><div class="ttdef"><b>Definition:</b> menu.h:101</div></div>
<div class="ttc" id="classCManualPage1_html"><div class="ttname"><a href="classCManualPage1.html">CManualPage1</a></div><div class="ttdoc">First page of manual. </div><div class="ttdef"><b>Definition:</b> menu.h:74</div></div>
<div class="ttc" id="classCGamesMenu_html"><div class="ttname"><a href="classCGamesMenu.html">CGamesMenu</a></div><div class="ttdoc">Load game menu. </div><div class="ttdef"><b>Definition:</b> menu.h:59</div></div>
<div class="ttc" id="classCScoreMenu_html"><div class="ttname"><a href="classCScoreMenu.html">CScoreMenu</a></div><div class="ttdoc">Show score menu. </div><div class="ttdef"><b>Definition:</b> menu.h:68</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
